// -------------------------------------------------------------
//    Relief Mapping
//    eXgine 0.80
// 19/12/2007
// =============================================================
//   (++): Tristan Dean (twixn@twixn.com)
//   delphi: Georgy Moshkin (http://tmtlib.narod.ru)
//  eXgine: XProger (XProger@list.ru,
//                         http://www.xproger.mirgames.ru)
// -------------------------------------------------------------

//   eXgine  
//   ( help.html)
program test;

uses
  OpenGL, eXgine; //  eXgine


// -=(  )=-
var
    wall_tex: TTexture;    //  
    height_tex: TTexture;  //    

    shader: TShader; //      

// -=(       )=-

    shader_testTexture: TShUniform; //    
    shader_heightTexture: TShUniform; //      
    shader_eye: TShUniform; //    

    shader_tangent: TShUniform;  // 1)  :    
    shader_normal: TShUniform;   // 2)   
    shader_binormal: TShUniform; // 3)


// -=(   )=-
    type tVector4f = array[0..3] of single; //    
    var temp_vector:array[0..10] of TVector4f; //  

    g_fSpinX:single; //   
    g_fSpinY:single;

// -=(     )=-
function vec4(x,y,z,w:single):tVector4f;
var zztmp:tVector4f;
begin
 zztmp[0]:=x;
 zztmp[1]:=y;
 zztmp[2]:=z;
 zztmp[3]:=w;
 result:=zztmp;
end;

// -=(    )=-
procedure Update;
begin
//    Escape (  27)
  if inp.Down(27) then eX.Quit;

//  
  g_fSpinX:=g_fSpinX+inp.MDelta.X*0.2;
  g_fSpinY:=g_fSpinY+inp.MDelta.Y*0.2;
end;

// -=(   UNIFORM-   )=-
procedure setShaderConstants;
begin
  //      
  vfp.Uniform( shader_testTexture, 0);

  //        
  vfp.Uniform( shader_heightTexture, 1);

  //     ()
  temp_vector[0]:=vec4(0,0,0,1);
  vfp.Uniform( shader_eye,@temp_vector[0],SU_F4);

  //  , , 
  // (   -   
  //  - )
  temp_vector[1]:=vec4(1,0,0,0);
  vfp.Uniform( shader_tangent, @temp_vector[1],SU_F4 );

  temp_vector[2]:=vec4(0,0,1,0);
  vfp.Uniform( shader_normal, @temp_vector[2],SU_F4 );

  temp_vector[3]:=vec4(0,1,0,0);
  vfp.Uniform( shader_binormal, @temp_vector[3],SU_F4 );
end;

// -=(    )=-
procedure Render;
begin

  ogl.Clear(true, true); //  
  ogl.Set3D(45, 0.1, 512); //    

  //        
  glTranslatef( 0.0, 0.0, -4.0);
  glRotatef( -g_fSpinY, 1.0, 0.0, 0.0 );
  glRotatef( -g_fSpinX, 0.0, 1.0, 0.0 );

  vfp.Enable(shader); //  

  //    ()
  tex.Enable(wall_tex, 0); //   -   
  tex.Enable(height_tex, 1); //    -   

  //  ,      
  setShaderConstants;

  //   
   glBegin(GL_QUADS);

    glTexCoord2f(0,0);
    glVertex3f(-1,-1,0);

    glTexCoord2f(1,0);
    glVertex3f(1,-1,0);

    glTexCoord2f(1,1);
    glVertex3f(1,1,0);

    glTexCoord2f(0,1);
    glVertex3f(-1,1,0);
   glEnd;

  //  
  tex.Disable(0);
  tex.Disable(1);
  tex.Disable();

  //  
  vfp.Disable;

  //   2D - 
  ogl.Set2D(0, 0, wnd.Width, wnd.Height);

  //   
  glColor3f(1, 1, 1);

  //  FPS
  ogl.TextOut(0, 8, 16, PChar('FPS: ' + IntToStr(ogl.FPS)));
end;

// -=(   )=-
begin
  //    
  wnd.Create('GLSL   Delphi: RELIEF MAPPING -    eXgine 0.80');

  //    ,     
  eX.SetProc(PROC_UPDATE, @Update);
  eX.SetProc(PROC_RENDER, @Render);

  //   log-
  log.Print('Hello World!');

  //  :
  wall_tex := tex.Load('.\textures\wall.jpg');
  height_tex := tex.Load('.\textures\height.jpg');


 //  :
 vfp.Add('.\shaders\vertex_shader.txt');
 vfp.Add('.\shaders\fragment_shader.txt');

 //   ,     eXgine 
 //        
 // : ,    vertex_shader.txt 
 // [VP MOYSHADER]  [VP],    
 // vfp.Add('.\shaders\fragment_shader.txt', 'MOYSHADER')

 shader := vfp.Compile; //  GLSL 

  //    UNIFORM ,
  //    shader:

  shader_testTexture:= vfp.GetUniform( Shader, 'TestTexture' );
  shader_HeightTexture:= vfp.GetUniform( Shader, 'HeightTexture' );
  shader_Eye:=vfp.GetUniform( Shader, 'Eye' );
  shader_Tangent:=vfp.GetUniform( Shader, 'Tangent' );
  shader_Normal:=vfp.GetUniform( Shader, 'Normal' );
  shader_BiNormal:=vfp.GetUniform( Shader, 'BiNormal' );

  glFinish; // -    

   inp.MCapture(true); //  "" 

  //    
  wnd.Mode(False, 640, 480, 32, 75);

  //    
  eX.MainLoop(50);
end.

